diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-users.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-users.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-users.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-users.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 45,77 ****
  	wp_die( __('Invalid site ID.') );
  
  $details = get_blog_details( $id );
! if ( !can_edit_network( $details->site_id ) )
  	wp_die( __( 'You do not have permission to access this page.' ) );
  
  $is_main_site = is_main_site( $id );
  
! // get blog prefix
! $blog_prefix = $wpdb->get_blog_prefix( $id );
  
! // @todo This is a hack. Eventually, add API to WP_Roles allowing retrieval of roles for a particular blog.
! if ( ! empty($wp_roles->use_db) ) {
! 	$editblog_roles = get_blog_option( $id, "{$blog_prefix}user_roles" );
! } else {
! 	// Roles are stored in memory, not the DB.
! 	$editblog_roles = $wp_roles->roles;
! }
! $default_role = get_blog_option( $id, 'default_role' );
  
  $action = $wp_list_table->current_action();
  
  if ( $action ) {
- 	switch_to_blog( $id );
  
  	switch ( $action ) {
  		case 'newuser':
  			check_admin_referer( 'add-user', '_wpnonce_add-new-user' );
  			$user = $_POST['user'];
! 			if ( !is_array( $_POST['user'] ) || empty( $user['username'] ) || empty( $user['email'] ) ) {
  				$update = 'err_new';
  			} else {
  				$password = wp_generate_password( 12, false);
--- 45,70 ----
  	wp_die( __('Invalid site ID.') );
  
  $details = get_blog_details( $id );
! if ( ! can_edit_network( $details->site_id ) )
  	wp_die( __( 'You do not have permission to access this page.' ) );
  
  $is_main_site = is_main_site( $id );
  
! switch_to_blog( $id );
  
! $editblog_roles = $wp_roles->roles;
! 
! $default_role = get_option( 'default_role' );
  
  $action = $wp_list_table->current_action();
  
  if ( $action ) {
  
  	switch ( $action ) {
  		case 'newuser':
  			check_admin_referer( 'add-user', '_wpnonce_add-new-user' );
  			$user = $_POST['user'];
! 			if ( ! is_array( $_POST['user'] ) || empty( $user['username'] ) || empty( $user['email'] ) ) {
  				$update = 'err_new';
  			} else {
  				$password = wp_generate_password( 12, false);
***************
*** 94,99 ****
--- 87,93 ----
  				$newuser = $_POST['newuser'];
  				$userid = $wpdb->get_var( $wpdb->prepare( "SELECT ID FROM " . $wpdb->users . " WHERE user_login = %s", $newuser ) );
  				if ( $userid ) {
+ 					$blog_prefix = $wpdb->get_blog_prefix( $id );
  					$user = $wpdb->get_var( "SELECT user_id FROM " . $wpdb->usermeta . " WHERE user_id='$userid' AND meta_key='{$blog_prefix}capabilities'" );
  					if ( $user == false )
  						add_user_to_blog( $id, $userid, $_POST['new_role'] );
***************
*** 108,114 ****
  			break;
  
  		case 'remove':
! 			if ( !current_user_can('remove_users')  )
  				die(__('You can&#8217;t remove users.'));
  			check_admin_referer( 'bulk-users' );
  
--- 102,108 ----
  			break;
  
  		case 'remove':
! 			if ( ! current_user_can( 'remove_users' )  )
  				die(__('You can&#8217;t remove users.'));
  			check_admin_referer( 'bulk-users' );
  
***************
*** 143,149 ****
  					if ( !is_user_member_of_blog( $user_id ) )
  						wp_die(__('Cheatin&#8217; uh?'));
  
! 					$user = new WP_User( $user_id );
  					$user->set_role( $_REQUEST['new_role'] );
  				}
  			} else {
--- 137,143 ----
  					if ( !is_user_member_of_blog( $user_id ) )
  						wp_die(__('Cheatin&#8217; uh?'));
  
! 					$user = get_userdata( $user_id );
  					$user->set_role( $_REQUEST['new_role'] );
  				}
  			} else {
***************
*** 152,162 ****
  			break;
  	}
  
- 	restore_current_blog();
  	wp_safe_redirect( add_query_arg( 'update', $update, $referer ) );
  	exit();
  }
  
  if ( isset( $_GET['action'] ) && 'update-site' == $_GET['action'] ) {
  	wp_safe_redirect( $referer );
  	exit();
--- 146,157 ----
  			break;
  	}
  
  	wp_safe_redirect( add_query_arg( 'update', $update, $referer ) );
  	exit();
  }
  
+ restore_current_blog();
+ 
  if ( isset( $_GET['action'] ) && 'update-site' == $_GET['action'] ) {
  	wp_safe_redirect( $referer );
  	exit();
***************
*** 244,250 ****
  <?php $wp_list_table->views(); ?>
  
  <form method="post" action="site-users.php?action=update-site">
- 	<?php wp_nonce_field( 'edit-site' ); ?>
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  
  <?php $wp_list_table->display(); ?>
--- 239,244 ----
***************
*** 254,268 ****
  <?php do_action( 'network_site_users_after_list_table', '' );?>
  
  <?php if ( current_user_can( 'promote_users' ) && apply_filters( 'show_network_site_users_add_existing_form', true ) ) : ?>
! <h4 id="add-user"><?php _e('Add User to This Site') ?></h4>
! 	<?php if ( current_user_can( 'create_users' ) && apply_filters( 'show_network_site_users_add_new_form', true ) ) : ?>
! <p><?php _e( 'You may add from existing network users, or set up a new user to add to this site.' ); ?></p>
! 	<?php else : ?>
! <p><?php _e( 'You may add from existing network users to this site.' ); ?></p>
! 	<?php endif; ?>
! <h5 id="add-existing-user"><?php _e('Add Existing User') ?></h5>
  <form action="site-users.php?action=adduser" id="adduser" method="post">
- 	<?php wp_nonce_field( 'edit-site' ); ?>
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  	<table class="form-table">
  		<tr>
--- 248,255 ----
  <?php do_action( 'network_site_users_after_list_table', '' );?>
  
  <?php if ( current_user_can( 'promote_users' ) && apply_filters( 'show_network_site_users_add_existing_form', true ) ) : ?>
! <h3 id="add-existing-user"><?php _e( 'Add Existing User' ); ?></h3>
  <form action="site-users.php?action=adduser" id="adduser" method="post">
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  	<table class="form-table">
  		<tr>
***************
*** 270,297 ****
  			<td><input type="text" class="regular-text wp-suggest-user" name="newuser" id="newuser" /></td>
  		</tr>
  		<tr>
! 			<th scope="row"><?php _e( 'Role'); ?></th>
  			<td><select name="new_role" id="new_role_0">
  			<?php
  			reset( $editblog_roles );
! 			foreach ( $editblog_roles as $role => $role_assoc ){
  				$name = translate_user_role( $role_assoc['name'] );
! 				$selected = ( $role == $default_role ) ? 'selected="selected"' : '';
! 				echo '<option ' . $selected . ' value="' . esc_attr( $role ) . '">' . esc_html( $name ) . '</option>';
  			}
  			?>
  			</select></td>
  		</tr>
  	</table>
  	<?php wp_nonce_field( 'add-user', '_wpnonce_add-user' ) ?>
! 	<?php submit_button( __('Add User'), 'primary', 'add-user', false, array( 'id' => 'submit-add-existing-user' ) ); ?>
  </form>
  <?php endif; ?>
  
  <?php if ( current_user_can( 'create_users' ) && apply_filters( 'show_network_site_users_add_new_form', true ) ) : ?>
! <h5 id="add-new-user"><?php _e('Add New User') ?></h5>
  <form action="<?php echo network_admin_url('site-users.php?action=newuser'); ?>" id="newuser" method="post">
- 	<?php wp_nonce_field( 'edit-site' ); ?>
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  	<table class="form-table">
  		<tr>
--- 257,282 ----
  			<td><input type="text" class="regular-text wp-suggest-user" name="newuser" id="newuser" /></td>
  		</tr>
  		<tr>
! 			<th scope="row"><?php _e( 'Role' ); ?></th>
  			<td><select name="new_role" id="new_role_0">
  			<?php
  			reset( $editblog_roles );
! 			foreach ( $editblog_roles as $role => $role_assoc ) {
  				$name = translate_user_role( $role_assoc['name'] );
! 				echo '<option ' . selected( $default_role, $role, false ) . ' value="' . esc_attr( $role ) . '">' . esc_html( $name ) . '</option>';
  			}
  			?>
  			</select></td>
  		</tr>
  	</table>
  	<?php wp_nonce_field( 'add-user', '_wpnonce_add-user' ) ?>
! 	<?php submit_button( __( 'Add User' ), 'primary', 'add-user', true, array( 'id' => 'submit-add-existing-user' ) ); ?>
  </form>
  <?php endif; ?>
  
  <?php if ( current_user_can( 'create_users' ) && apply_filters( 'show_network_site_users_add_new_form', true ) ) : ?>
! <h3 id="add-new-user"><?php _e( 'Add New User' ); ?></h3>
  <form action="<?php echo network_admin_url('site-users.php?action=newuser'); ?>" id="newuser" method="post">
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  	<table class="form-table">
  		<tr>
***************
*** 303,316 ****
  			<td><input type="text" class="regular-text" name="user[email]" /></td>
  		</tr>
  		<tr>
! 			<th scope="row"><?php _e( 'Role'); ?></th>
  			<td><select name="new_role" id="new_role_0">
  			<?php
  			reset( $editblog_roles );
! 			foreach ( $editblog_roles as $role => $role_assoc ){
  				$name = translate_user_role( $role_assoc['name'] );
! 				$selected = ( $role == $default_role ) ? 'selected="selected"' : '';
! 				echo '<option ' . $selected . ' value="' . esc_attr( $role ) . '">' . esc_html( $name ) . '</option>';
  			}
  			?>
  			</select></td>
--- 288,300 ----
  			<td><input type="text" class="regular-text" name="user[email]" /></td>
  		</tr>
  		<tr>
! 			<th scope="row"><?php _e( 'Role' ); ?></th>
  			<td><select name="new_role" id="new_role_0">
  			<?php
  			reset( $editblog_roles );
! 			foreach ( $editblog_roles as $role => $role_assoc ) {
  				$name = translate_user_role( $role_assoc['name'] );
! 				echo '<option ' . selected( $default_role, $role, false ) . ' value="' . esc_attr( $role ) . '">' . esc_html( $name ) . '</option>';
  			}
  			?>
  			</select></td>
***************
*** 320,326 ****
  		</tr>
  	</table>
  	<?php wp_nonce_field( 'add-user', '_wpnonce_add-new-user' ) ?>
! 	<?php submit_button( __('Add New User'), 'primary', 'add-user', false, array( 'id' => 'submit-add-user' ) ); ?>
  </form>
  <?php endif; ?>
  </div>
--- 304,310 ----
  		</tr>
  	</table>
  	<?php wp_nonce_field( 'add-user', '_wpnonce_add-new-user' ) ?>
! 	<?php submit_button( __( 'Add New User' ), 'primary', 'add-user', true, array( 'id' => 'submit-add-user' ) ); ?>
  </form>
  <?php endif; ?>
  </div>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/themes.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/themes.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/themes.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/themes.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 13,23 ****
  if ( ! is_multisite() )
  	wp_die( __( 'Multisite support is not enabled.' ) );
  
- $menu_perms = get_site_option( 'menu_items', array() );
- 
- if ( empty( $menu_perms['themes'] ) && ! is_super_admin() )
- 	wp_die( __( 'Cheatin&#8217; uh?' ) );
- 
  if ( !current_user_can('manage_network_themes') )
  	wp_die( __( 'You do not have sufficient permissions to manage network themes.' ) );
  
--- 13,18 ----
***************
*** 181,190 ****
  				exit;
  			} // Endif verify-delete
  
! 			foreach ( $themes as $theme )
! 				$delete_result = delete_theme( $theme, esc_url( add_query_arg( array('verify-delete' => 1), $_SERVER['REQUEST_URI'] ) ) );
  			$paged = ( $_REQUEST['paged'] ) ? $_REQUEST['paged'] : 1;
! 			wp_redirect( network_admin_url( "themes.php?deleted=".count( $themes )."&paged=$paged&s=$s" ) );
  			exit;
  			break;
  	}
--- 176,196 ----
  				exit;
  			} // Endif verify-delete
  
! 			foreach ( $themes as $theme ) {
! 				$delete_result = delete_theme( $theme, esc_url( add_query_arg( array(
! 					'verify-delete' => 1,
! 					'action' => 'delete-selected',
! 					'checked' => $_REQUEST['checked'],
! 					'_wpnonce' => $_REQUEST['_wpnonce']
! 				), network_admin_url( 'themes.php' ) ) ) );
! 			}
! 			
  			$paged = ( $_REQUEST['paged'] ) ? $_REQUEST['paged'] : 1;
! 			wp_redirect( add_query_arg( array(
! 				'deleted' => count( $themes ),
! 				'paged' => $paged,
! 				's' => $s
! 			), network_admin_url( 'themes.php' ) ) );
  			exit;
  			break;
  	}
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/upgrade.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/upgrade.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/upgrade.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/upgrade.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 60,68 ****
  		}
  		echo "<ul>";
  		foreach ( (array) $blogs as $details ) {
! 			$siteurl = get_blog_option( $details['blog_id'], 'siteurl' );
  			echo "<li>$siteurl</li>";
! 			$response = wp_remote_get( trailingslashit( $siteurl ) . "wp-admin/upgrade.php?step=upgrade_db", array( 'timeout' => 120, 'httpversion' => '1.1' ) );
  			if ( is_wp_error( $response ) )
  				wp_die( sprintf( __( 'Warning! Problem updating %1$s. Your server may not be able to connect to sites running on it. Error message: <em>%2$s</em>' ), $siteurl, $response->get_error_message() ) );
  			do_action( 'after_mu_upgrade', $response );
--- 60,71 ----
  		}
  		echo "<ul>";
  		foreach ( (array) $blogs as $details ) {
! 			switch_to_blog( $details['blog_id'] );
! 			$siteurl = site_url();
! 			$upgrade_url = admin_url( 'upgrade.php?step=upgrade_db' );
! 			restore_current_blog();
  			echo "<li>$siteurl</li>";
! 			$response = wp_remote_get( $upgrade_url, array( 'timeout' => 120, 'httpversion' => '1.1' ) );
  			if ( is_wp_error( $response ) )
  				wp_die( sprintf( __( 'Warning! Problem updating %1$s. Your server may not be able to connect to sites running on it. Error message: <em>%2$s</em>' ), $siteurl, $response->get_error_message() ) );
  			do_action( 'after_mu_upgrade', $response );
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/users.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/users.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/users.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/users.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 24,30 ****
  	screen_icon();
  	?>
  	<h2><?php esc_html_e( 'Users' ); ?></h2>
! 	<p><?php _e( 'Transfer or delete posts and links before deleting users.' ); ?></p>
  	<form action="users.php?action=dodelete" method="post">
  	<input type="hidden" name="dodelete" />
  	<?php
--- 24,30 ----
  	screen_icon();
  	?>
  	<h2><?php esc_html_e( 'Users' ); ?></h2>
! 	<p><?php _e( 'Transfer or delete posts before deleting users.' ); ?></p>
  	<form action="users.php?action=dodelete" method="post">
  	<input type="hidden" name="dodelete" />
  	<?php
***************
*** 34,40 ****
  
  	foreach ( ( $allusers = (array) $_POST['allusers'] ) as $key => $val ) {
  		if ( $val != '' && $val != '0' ) {
! 			$delete_user = new WP_User( $val );
  
  			if ( ! current_user_can( 'delete_user', $delete_user->ID ) )
  				wp_die( sprintf( __( 'Warning! User %s cannot be deleted.' ), $delete_user->user_login ) );
--- 34,40 ----
  
  	foreach ( ( $allusers = (array) $_POST['allusers'] ) as $key => $val ) {
  		if ( $val != '' && $val != '0' ) {
! 			$delete_user = get_userdata( $val );
  
  			if ( ! current_user_can( 'delete_user', $delete_user->ID ) )
  				wp_die( sprintf( __( 'Warning! User %s cannot be deleted.' ), $delete_user->user_login ) );
***************
*** 47,53 ****
  
  			if ( !empty( $blogs ) ) {
  				?>
! 				<br /><fieldset><p><legend><?php printf( __( "What should be done with posts and links owned by <em>%s</em>?" ), $delete_user->user_login ); ?></legend></p>
  				<?php
  				foreach ( (array) $blogs as $key => $details ) {
  					$blog_users = get_users( array( 'blog_id' => $details->userblog_id ) );
--- 47,53 ----
  
  			if ( !empty( $blogs ) ) {
  				?>
! 				<br /><fieldset><p><legend><?php printf( __( "What should be done with posts owned by <em>%s</em>?" ), $delete_user->user_login ); ?></legend></p>
  				<?php
  				foreach ( (array) $blogs as $key => $details ) {
  					$blog_users = get_users( array( 'blog_id' => $details->userblog_id ) );
***************
*** 67,75 ****
  						<ul style="list-style:none;">
  							<li><?php printf( __( 'Site: %s' ), $user_site ); ?></li>
  							<li><label><input type="radio" id="delete_option0" name="delete[<?php echo $details->userblog_id . '][' . $delete_user->ID ?>]" value="delete" checked="checked" />
! 							<?php _e( 'Delete all posts and links.' ); ?></label></li>
  							<li><label><input type="radio" id="delete_option1" name="delete[<?php echo $details->userblog_id . '][' . $delete_user->ID ?>]" value="reassign" />
! 							<?php echo __( 'Attribute all posts and links to:' ) . '</label>' . $user_dropdown; ?></li>
  						</ul>
  						<?php
  					}
--- 67,75 ----
  						<ul style="list-style:none;">
  							<li><?php printf( __( 'Site: %s' ), $user_site ); ?></li>
  							<li><label><input type="radio" id="delete_option0" name="delete[<?php echo $details->userblog_id . '][' . $delete_user->ID ?>]" value="delete" checked="checked" />
! 							<?php _e( 'Delete all posts.' ); ?></label></li>
  							<li><label><input type="radio" id="delete_option1" name="delete[<?php echo $details->userblog_id . '][' . $delete_user->ID ?>]" value="reassign" />
! 							<?php echo __( 'Attribute all posts to:' ) . '</label>' . $user_dropdown; ?></li>
  						</ul>
  						<?php
  					}
***************
*** 139,146 ****
  							break;
  
  							case 'spam':
! 								$user = new WP_User( $val );
! 								if ( in_array( $user->user_login, get_super_admins() ) )
  									wp_die( sprintf( __( 'Warning! User cannot be modified. The user %s is a network administrator.' ), esc_html( $user->user_login ) ) );
  
  								$userfunction = 'all_spam';
--- 139,146 ----
  							break;
  
  							case 'spam':
! 								$user = get_userdata( $val );
! 								if ( is_super_admin( $user->ID ) )
  									wp_die( sprintf( __( 'Warning! User cannot be modified. The user %s is a network administrator.' ), esc_html( $user->user_login ) ) );
  
  								$userfunction = 'all_spam';
